<template>
	<div class="layer-bg">
		<client-only>
			<MkPageSpinner v-if="SHOW_PAGE_SPINNER" />
			<div
				class="sticky top-0 z-40 flex items-center justify-between px-4 py-5 text-sm bg-white border-b max-h-header-75 md:px-6 lg:px-12 border-grey-20"
			>
				<div class="flex relative w-full">
					<NuxtLink to="/" class="w-32 mx-auto">
						<img tabindex="0" src="~/assets/images/MKLogoBlack.jpg" alt="Molekule Logo" />
					</NuxtLink>
					<div class="absolute right-0 hidden md:grid grid-cols-3 gap-x-8">
						<MkFreeShipping />
						<MkReturn />
						<MkWarranty />
					</div>
				</div>
			</div>
			<div class="flex flex-col mx-auto max-w-screen-xl">
				<p
					class="font-secondary-font-regular px-4 md:px-10 lg:px-5 text-2xl md:text-28 lg:text-5xl py-6 md:py-10"
					v-html="page.checkout"
				></p>
				<div class="flex flex-col lg:flex-row max-w-screen-xl md:px-10 lg:px-5 justify-between">
					<MkCheckoutLayout :page="page" @payment-data="setPayment" />
					<MkCheckoutOrderSummary :payment-detail="paymentData" />
				</div>
			</div>
			<MkSideCart />
		</client-only>
	</div>
</template>
<script>
import { mapState } from 'vuex';
import MkCheckoutOrderSummary from '~/components/D2C/organisms/MkCheckoutOrderSummary.vue';
import MkCheckoutLayout from '~/components/D2C/organisms/MkCheckoutLayout.vue';
import MkPageSpinner from '~/components/D2C/atoms/MkPageSpinner/MkPageSpinner.vue';
import MkFreeShipping from '~/components/D2C/atoms/MkFreeShipping.vue';
import MkReturn from '~/components/D2C/atoms/MkReturn.vue';
import MkWarranty from '~/components/D2C/atoms/MkWarranty.vue';
import MkSideCart from '~/components/D2C/organisms/MkSideCart/MkSideCart.vue';
export default {
	components: {
		MkCheckoutLayout,
		MkCheckoutOrderSummary,
		MkPageSpinner,
		MkFreeShipping,
		MkReturn,
		MkWarranty,
		MkSideCart,
	},
	layout: 'aurora-layout',
	middleware: 'auth',
	async asyncData({ store, req }) {
		return { page: await store.dispatch('pages/FETCH_PAGE_DATA', { pageName: 'my_checkout_page', req }) };
	},
	data() {
		return {
			paymentData: {},
			tabhandler: '',
			mouseClick: '',
			cmsData: {
				freeGroundMessage: 'CMS - Free ground shipping. Most devices ship the next business day',
			},
		};
	},
	head() {
		return {
			title: 'Checkout',
			htmlAttrs: {
				class: 'no-header',
			},
		};
	},
	computed: {
		...mapState('USER_STORE', ['AUTHENTICATED']),
		...mapState('CHECKOUT_STORE', ['SHOW_PAGE_SPINNER']),
	},
	beforeMount() {
		this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
	},
	async mounted() {
		await this.$store.dispatch('CHECKOUT_STORE/CHECK_LOCALE_FOR_FEATURE');
		await this.$store.dispatch('CART_STORE/FETCH_CART', {});
		if (this.AUTHENTICATED) {
			await this.$store.dispatch('USER_STORE/FETCH_CUSTOMER');
		}
		this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
		this.tabhandler = function (e) {
			if (e.keyCode === 9) {
				document.body.classList.add('tab-key-press');
				window.removeEventListener('keyup', this.tabhandler);
			}
		};
		this.mouseClick = function (e) {
			document.body.classList.remove('tab-key-press');
			window.removeEventListener('click', this.mouseClick);
		};
		window.addEventListener('keyup', this.tabhandler);
		window.addEventListener('click', this.mouseClick);
	},
	methods: {
		setPayment($data) {
			this.paymentData = $data;
		},
	},
};
</script>
